INSTALL_HIERARCHICAL_FILES_MK =

# PREREQUISITES

TAR +=
MKDIR_P +=

## this snippet defines a sequence of shell commands which will
##
##   * install files to a directory hierarchically
##   * uninstall files from a directory hierarchically
##
## To use this, set these shell variables
##
##  files - the files to copy
##  dir   - the directory where the files are to be installed
##
## and then interpolate $(install_files).  For example
##
##
##  files=$(_HTML); dir=$(htmldir); $(install_files)

## use tar to make life easier
install_hierarchical_files = \
	$(MKDIR_P) $(DESTDIR)$$dir; \
	echo $${files} | $(PERL) -p -e 's/ /\0/g; s/\n//;' | $(TAR) --null -T - -c | { cd "$(DESTDIR)$${dir}" ; tar xf -; }


uninstall_hierarchical_files = \
	echo $${files} \
        | $(PERL) -p -e 's/ /\n/g' \
	| { cd "$(DESTDIR)$${dir}"; \
	    chmod +w . ;\
	    while read entry; do \
	      if  test -d "$$entry" -a "$$entry" != '.' -a "$$entry" != './'; then \
	        chmod +w "$$entry" ;\
		echo "$${\#entry} $$entry" ;\
	      elif test -f "$$entry"; then \
		rm -f "$$entry" ; \
		p="$$entry"; entry=$(mst__dirname); \
	        chmod +w "$$entry" ;\
		echo "$${\#entry} $$entry" ;\
              else \
		echo 1>&2 "can't find $$entry" ; \
              fi;\
	    done \
	   |sort -nru \
	   |while read len entry; do rmdir $$entry ; done ;\
	  }
